---------------------------------------------------------------------------
--               client->termin->inter->config->center := Elhoim !
--                                      |
-- hander->cyborg->intell->engine  ->	acces server_record
---------------------------------------------------------------------------
--           Neural network (Layer 0 -> Hander
--                          |   \/               cyborg -> Search->Path_Finding
--                         /\   |                intell -> Manual
--           Neural network (layer 1 -> Engine /
--                           |                 /  \
--                          /\               \/     \
--                               [ server ]           Lexic
---------------------------------------------------------------------------
--                             Modes and Multi - mode                    --
---------------------------------------------------------------------------
---------------------------------------------------------------------------
--                              Simple mode
---------------------------------------------------------------------------
--   type Mode_Enum is (Null_Mode, Quit_Mode, Auth_Mode, Dialog_Mode, 
--		      Devel_Mode, Organizer_Mode, Multi_Mode, Shell_Mode, 
--		      Execut_mode, Help_Mode);
---------------------------------------------------------------------------
--
--  F1) Dialog mode : depend of Joshua
--  F2) Devel mode  : depend of Manuel
--  F3) Orga mode   : depend of Prehander befor Adaline
--  F4) Multi mode  : depend of gnaies
--  F5) Shell mode  : depend of Adamanborg
--  F6) Exec mode   : non implemented
--
---------------------------------------------------------------------------
--                          Multi mode mode
---------------------------------------------------------------------------
--   type Multi_Enum is (Edit_Mode, Command_Mode, 
--		       Account_Mode, Tasking, Hander_Mode);
---------------------------------------------------------------------------
-- Default) Command  : Depend of gnaies
-- F7) Editor        : depend of gnaies
-- F8) Account       : depend of gnaies
-- F9 Tasking mode   : non implemented
---------------------------------------------------------------------------
--                               Terminals
---------------------------------------------------------------------------
--   type Term_Enum is (Linux, Xterm, Uncknow, MS_Windows);
---------------------------------------------------------------------------
-- Linux      : implemented tested
-- xterm      : implemented non tested
-- uncknow    : non implemented
-- MS_Windows : non implmented
---------------------------------------------------------------------------
--                Self execution and complilation                        --
---------------------------------------------------------------------------
-- Main : Adamnborg or Gnostic                                           --
-- Source editing : Adamanborg or Gnostic                                --
---------------------------------------------------------------------------
-- String buffer with active wait : look_haead
---------------------------------------------------------------------------
-- make : all, update, edit version, mrproper, all, clean, enlight, arch --
---------------------------------------------------------------------------
--                     Version 0.2.x  Version-2023                       --
---------------------------------------------------------------------------
--                                                                       --
--                   Self finalization by path finding                   --
--                                                                       --
-- Path search with A* in object set created with an dubble neural network.
---------------------------------------------------------------------------
--               Main datas in traitment in this application             --
---------------------------------------------------------------------------
--                            Player record                              --
---------------------------------------------------------------------------
-- type Identity_Record is tagged
--       record
-- 	 Username  : access String;
-- 	 Full_Name : access String;
-- 	 Address   : access String;
-- 	 City_Code : access String;
-- 	 City_Name : access String;
-- 	 Phone_Nb  : access String;
-- 	 Email     : access String;
-- 	 Web_Addr  : access String;
--       end record;
   
-- type User_Record is new Identity_Record with
--       record
-- 	 Home_Path  : access String;
-- 	 Last_Visit : access Date_Record;
--       end record;
-- (See lib.player for full declaration.)
----------------------------------------------------------------------------
--                        Ai info record                                  --
----------------------------------------------------------------------------
   -- type Nn_Info_Record is tagged
   --    record
   -- 	 RMS_Error     : Float := 0.0;	 
   -- 	 Current_Epoch : Natural := 0;
   -- 	 Converged     : Boolean := False;
   --    end record;
   
   -- type Class_Info_Record is tagged
   --   record
   -- 	Current_Tag   : Tag_Name := Null_Tag;
   -- 	Hcost         : Float := 0.0;
   -- 	Ucos          : Float := 0.0;	
   --   end record;
   
   -- Null_Tag_Info : constant Class_Info_Record := (Null_Tag, 0.0, 0.0);
   
   -- type Class_Rank is array
   --           (Positive range 1..Tag_Name'Length) of Class_Info_Record;
   
   -- type Path_Info is tagged
   --    record
   -- 	 Rankning     : Class_Rank := (others => Null_Tag_Info);
   -- 	 Close_Size   : Natural := 0;
   -- 	 Open_Size    : Natural := 0;
   --    end record;
   
   -- type Aiinfo_Record is new Path_Info with     
   --    record
   -- 	 Layer_0       : Nn_Info_Record;
   -- 	 Layer_2       : Nn_Info_Record;	 
   -- 	 Veritable     : Boolean := False;
   -- 	 Veracity      : Boolean := False;
   -- 	 Verified      : Boolean := False;
   -- 	 State         : Boolean := False;
   --    end record;
   -- (see lib.aiinfo for full declaration.)
   -----------------------------------------------------------------------
   --                         Document record                           --
   -----------------------------------------------------------------------
   -- type Docume_Record is tagged
   --    record
   -- 	 Title    : Wide_String_Access;
   -- 	 Filename : String_Access;
   -- 	 Fullpath : String_Access;
   -- 	 Unit     : String_Accesss;
   -- 	 Creation_Date : Time;
   -- 	 Last_Edition  : Time;
   -- 	 Openned       : Boolean := False;
   -- 	 Is_New_Doc    : Boolean := False;
   -- 	 Size          : natural := 0;
   -- 	 Owner         : Wide_String_Acces;	 
   --    end record;
   -- (see lib.docum for full declaration.)
   ------------------------------------------------------------------------
   --                     Ternary resukt record                          --
   ------------------------------------------------------------------------
  --  type Result_Record is tagged
  -- 	 record     
  -- 	    Know    : Boolean := True;
  -- 	    Have    : Boolean := True;
  -- 	    Peace   : Ternary_Enum := Uncknow;
  -- 	    Love    : Ternary_Enum := Uncknow;
  -- 	    War     : Ternary_Enum := Uncknow;
  -- 	    Reason  : Boolean := False;
  -- 	    Freedom : Boolean := False;
  -- 	    Power   : Ternary_Enum := Uncknow;
  -- 	    Will    : Ternary_Enum := Uncknow;
  -- 	    Loose   : Ternary_Enum := uncknow;       
  -- 	 end record;      
  -- type Preuve_Record is new Result_Record with
  -- 	 record
  -- 	    Veritable : Boolean := false;
  -- 	    Veracity  : Boolean := False;
  -- 	    Verified  : Boolean := False;
  -- 	 end record;
  -- (see lib.axiomes for full declaration.)
---------------------------------------------------------------------------
--                     Computing execution result                        --
---------------------------------------------------------------------------
-- type Result_Enum is (File, Search, Spawn);
   
--    type Result_Record (Name : Result_Enum) is tagged
--       record
-- 	 Wlines : U_Array_Access;
-- 	 Count  : Natural := 0;
-- 	 Initialized : Boolean := False;
-- 	 case Name is
-- 	    when File =>
-- 	       null;
-- 	    when Search =>
-- 	       Pattern   : Wide_String_Access := new Wide_String ' ("");
-- 	       Address   : Os_Lib.String_Access;
-- 	       Doc_Name  : Wide_String_Access;
-- 	    when Spawn =>
-- 	       Process_Id     : Gnat.Os_Lib.Process_Id;
-- 	       Program_Name   : U_String;
-- 	       Args           : Os_Lib.Argument_List_Access;	 
-- 	       Output_File    : U_String;
-- 	       Success        : Boolean := False;
-- 	       Return_Code    : Integer := 0;
-- 	       Err_To_Out     : Boolean := False;	 
-- 	 end case;
	 
--       end record;
-- (see lib.result for full declaration.)
--
---------------------------------------------------------------------------
--                                                                       --
--                      Main use case of Elhoim 0.2.x                    --
--                                                                       --
--                                            Server                     --
--                 Server -> Elhoim -> User /                            --
--                                          \                            --
--                                            Elhoim                     --
--                                                                       --
--                                                                       --
---------------------------------------------------------------------------
--                                                                       --
--   Main server : 'elhoim -a'                                           --
--                                                                       --
--                                                                       --
--                                                                       --
--                                                                       --
--  Clients  : 'elhoim' => Create_Object -> Elhoim.Proposition(Object) ; --
--                                                                       --
--  Elhoim.Send(accepted : out boolean);                                 --
--                                                                       --
--  Clients  : 'elhoim' => Elhoim.Request(Proposition) ;                 --
--                                                                       --
--  Elhoim.Respond(Response)...                                          --
--                                                                       --
--  Client  : Server.Request(Object, Response) ;                         --
--                                                                       --
--  Client  : Path_Finding (Objects_Tree, Object.Set) ;                  --
--                                                                       --
--  Client : 'elhoim' : Elhoim.Subject(New_Path) ;                       --
--                                                                       --
--  Elhoim.Edition(Sources) -> Elhoim.Compilation -> New version.        --
--                                                                       --
---------------------------------------------------------------------------
--                                                                       --
--                   Main use case description                           --
--                                                                       --
---------------------------------------------------------------------------
---------------------------------------------------------------------------
--                                                                       --
--                           French version :                            --
--                                                                       --
--      Système client/server d'objets existants et à créer par la       --
--  proposition d'idée sémantique correspondante d'un état ordonné       --
--  des objets existant exprimé par une recherche de chemin créateur     --
--  de nouveaux objets.                                                  --
--                                                                       --
--                                                                       --
---------------------------------------------------------------------------
-- type Object_Info_Record is new Class_Info_Record with
--       record
-- 	 Name : Name_Type := (others => Wide_Character ' Val (32));
-- 	 Old  : Duration := 0.0;
-- 	 X    : Vector_Type := 0.0;
-- 	 Y    : Vector_Type := 0.0;
-- 	 Z    : Vector_Type := 0.0;
--       end record;
   
   
--    type Object_Info_Access is access Object_Info_Record;
   
--    type Object_Array is array (Positive range <>) of Object_Info_Access;
   
--    type Object_Set(Object_Max : Positive) is
--       record
-- 	 Set : Object_Array(1..Object_Max);
-- 	 Object_Last : Natural := 0;
--       end record;
   
--    type Ai_Domain(Max_Object : Positive) is new Aiinfo_Record with
--       record
-- 	 Objects : Object_Set(Max_Object);
-- 	 Proof   : Preuve_Record;
--       end record;
---------------------------------------------------------------------------
--                                                                       --
--                      Tasking center program                           --
--                                                                       --
---------------------------------------------------------------------------
---------------------------------------------------------------------------
--                                          |                            --
--         Neural Network Layer 1           |  Neural Network Layer 2    --
--------------------------------------------|------------------------------
-- Dialog_Process <- Neural Network server  |                            --
--                                          | Dialog_Process -> Engine   --
---------------------------------------------------------------------------
--                                          | Server <- Engine           --
--      Terminal  -  Client  <- Server      |                            --
---------------------------------------------------------------------------
--  Terminal -> interf -> config -> Center -> Elhoim -> Dialog           --
--------------------------------------------|      | -> Devel            --
-- Hander -> Intell | -> Engine  <- Server  |   <- | -> Organizer        --
---------------------------------------------------------------------------

