-- This program is the last attempt of artificial intelligency with Ada.
-- Elhoim is Copyright (C) 2023 Manuel ; 
--
--   This program is free software; you can redistribute it and/or modify
--   it under the terms of the GNU General Public License as published by
--   the Free Software Foundation; either version 2 of the License, or
--   (at your option) any later version.
--
--   This program is distributed in the hope that it will be useful,
--   but WITHOUT ANY WARRANTY; without even the implied warranty of
--   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
--   GNU General Public License for more details.
--
--   You should have received a copy of the GNU General Public License
--   along with this program; if not, write to the Free Software
--   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
--
-- Date := "2023-05-01 20:03:01"
-- Version := "1.0.0a"
with Lib.Strings;
package Lib.Attrib is
   use Strings;

   
   type All_Types is tagged
      record
	 Boo  : Boolean;
	 Int  : Integer;
	 Flt  : Float;	    
	 Str  : String_Access;	    
      end record;
   
   type attribut_Enum is (Nil, Boo, Int, Flt, Str);
   
   type Attribut_Record is new All_Types with
      record
	 Tags  : String_Access;
	 Value : String_Access;
	 Enum  : Attribut_Enum;
      end record;            
   
   
   
   type Attribut_Array is array (Positive range <>) of Attribut_Record;
   
   type Attributs (Max : Positive) is
      record
	 List : Attribut_Array(1..Max);
	 Index : Natural := 0;
      end record;

   procedure Parse (Line : in Wide_String; Name : out String_Access; Image : out String_Access);
   
   function Make (Names : in String; Value : in String) return Attribut_Record;
   function names (Att : in Attribut_Record) return String;
   function image (Att : in Attribut_Record) return String;


end Lib.Attrib ; 
