-- This program is the last attempt of artificial intelligency with Ada.
-- Elhoim is Copyright (C) 2023 Manuel ; 
--
--   This program is free software; you can redistribute it and/or modify
--   it under the terms of the GNU General Public License as published by
--   the Free Software Foundation; either version 2 of the License, or
--   (at your option) any later version.
--
--   This program is distributed in the hope that it will be useful,
--   but WITHOUT ANY WARRANTY; without even the implied warranty of
--   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
--   GNU General Public License for more details.
--
--   You should have received a copy of the GNU General Public License
--   along with this program; if not, write to the Free Software
--   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
--
-- Date := "2023-05-03 13:14:19"
-- Version := "1.0.0b"
with Lib.Strings;
generic
package Lib.Classe.Planning_class is
   use Strings;
   --------------------------------------------------------------------------
   --                    Planning                                          --
   
   function ressources_Value(Line : in Wide_String) return Wstring_32;
   function Get_Date_To(Line : in Wide_String) return Time;
   function Get_Date_from(Line : in Wide_String) return Time;
   
   type Planning_Class is new Abstracted_Class(Planning) with
      record
	 Description : Wstring_32;
	 From        : Time := Clock;
	 To          : Time := Clock;
      end record;
   
   function Create(Win       : in Window_Type;
		   Win_Index : in out Positive;
		   Name      : in Name_Type;
		   description   : in Wstring_32;
		   From          : in Time;
		   To            : in Time) return Abstracted_Access;
      
   procedure Print (Object    : in Planning_Class'Class;
		    Win       : in Window_Type;
		    Win_Index : in out Positive;
		    Name      : out Name_Type);
   
   procedure Help(Planning   : in out Planning_Class'Class;
		  Win       : in Window_Type;
		  Win_Index : in out Positive;
		  Name      : out Name_Type);
   
   
   
   
   
   
   
   procedure Write (O : in Planning_Class;File : in W_Io.File_Type);
   procedure Read (O : in out Planning_Class;File : in W_Io.File_Type);
   procedure Random (O : in out Planning_Class);
   
   --                 End Planning                                         --
   --------------------------------------------------------------------------


end Lib.Classe.Planning_class ; 
