-- This program is the last attempt of artificial intelligency with Ada.
-- Elhoim is Copyright (C) 2023 Manuel ; 
--
--   <one line to give the program's name and a brief idea of what it does.>
--   Copyright (C) 19yy  <name of author>
--
--   This program is free software; you can redistribute it and/or modify
--   it under the terms of the GNU General Public License as published by
--   the Free Software Foundation; either version 2 of the License, or
--   (at your option) any later version.
--
--   This program is distributed in the hope that it will be useful,
--   but WITHOUT ANY WARRANTY; without even the implied warranty of
--   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
--   GNU General Public License for more details.
--
--   You should have received a copy of the GNU General Public License
--   along with this program; if not, write to the Free Software
--   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
--
-- Date := "2023-05-01 20:03:01"
-- Version := "1.0.0a"

with Lib.Params ; 
with Lib.Option ;
with Lib.Termin ;
package Lib.Interf is
   
   type Interf_Record is new Termin.Termin_Record with
      record
	 Parameters_Kit : Params.Parameters_Kit_Record_Type;
	 Options_Kit    : Option.Options_Kit_Array_Type;	 
      end record;
   
   use Params;   

   procedure Initialize (Int : in out Interf_Record);
   
   procedure Parameters_Descriptions
     (From : in Interf_Record);
   procedure Print_Parameters (Interf : in Interf_Record'class);
   function Get_Parameter
     (From : in Interf_Record;
      Flag : in Parameters_Flags_Enum_Type)
     return Parameter_Tagged_Record_Type;      
   
   
   function Get_Lines (Int : in Interf_Record) return Positive;
   function Get_Cols (Int : in Interf_Record) return Positive;
   
   function Columns_Number (Line : in Wide_String) return Positive;
   function Lines_Number (Line : in Wide_String) return Positive;
private
   
   function Set_Parameters_From (Filename : in Wide_String)      
				return access Parameters_Kit_Record_Type;
end Lib.Interf ; 
