-- elhoim is full object organizer with editor and command interpreter.
-- Elhoim is Copyright (C) 2023 Manuel De Girardi ; 
--
--   This program is free software; you can redistribute it and/or modify
--   it under the terms of the GNU General Public License as published by
--   the Free Software Foundation; either version 2 of the License, or
--   (at your option) any later version.
--
--   This program is distributed in the hope that it will be useful,
--   but WITHOUT ANY WARRANTY; without even the implied warranty of
--   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
--   GNU General Public License for more details.
--
--   You should have received a copy of the GNU General Public License
--   along with this program; if not, write to the Free Software
--   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
--
-- Date := "2023-05-26 17:40:38"
-- Version := "0.6.6b"
with El.Strings;
generic
package El.Classe.Cars_class is
   use Strings;
   function Mark_Value(Line : in Wide_String) return Name_Type;
   function Car_genre_Value(Line : in Wide_String) return Name_Type;
   function Car_immat_Value(Line : in Wide_String) return Name_Type;
   --------------------------------------------------------------------------
   --                    ANIMAL                                            --
   
   type Car_Class is new Abstracted_Class(Car) with
      record
	 Mark : Name_Type := (others => ' ');
	 genre : Name_Type := (others => ' ');
	 Immat : Name_Type := (others => ' ');
      end record;
   
   function Create(Win       : in Window_Type;
		   Win_Index : in out Positive;
		   Name      : in Name_Type;
		   Mark      : in Name_Type;
		   genre     : in Name_Type;
		   Immat     : in Name_Type) return Abstracted_Access;
   
   procedure Print (Object    : in Car_Class'Class;
		    Win       : in Window_Type;
		    Win_Index : in out Positive;
		    Name      : out Name_Type);
   
   procedure Help(Car    : in out Car_Class'Class;
		  Win       : in Window_Type;
		  Win_Index : in out Positive;
		  Name      : out Name_Type);
   
   procedure Write (O : in Car_Class;File : in W_Io.File_Type);
   procedure Read (O : in out Car_Class;File : in W_Io.File_Type);
   procedure Random (O : in out Car_Class);
   
   --                 End ANIMAL                                           --
   --------------------------------------------------------------------------
   


end El.Classe.Cars_class ; 
