-- elhoim is full object organizer with editor and command interpreter.
-- Elhoim is Copyright (C) 2023 Manuel De Girardi ; 
--
--   This program is free software; you can redistribute it and/or modify
--   it under the terms of the GNU General Public License as published by
--   the Free Software Foundation; either version 2 of the License, or
--   (at your option) any later version.
--
--   This program is distributed in the hope that it will be useful,
--   but WITHOUT ANY WARRANTY; without even the implied warranty of
--   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
--   GNU General Public License for more details.
--
--   You should have received a copy of the GNU General Public License
--   along with this program; if not, write to the Free Software
--   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
--
-- Date := "2023-05-26 17:40:38"
-- Version := "0.6.6b"
with El.Strings;
with Ada.Calendar;
with Calendar;
package El.Docume is
   use Strings;
   use Calendar;
   type Docume_Record is tagged
      record
	 Title    : String_Access; --
	 Filename : String_Access; --
	 Fullpath : String_Access;
	 Unit     : String_Access; --
	 Creation_Date : Time; --
	 Last_Edition  : Time; --
	 Openned       : Boolean := False; --
	 Is_New_Doc    : Boolean := False;
	 Size          : natural := 0;
	 Owner         : String_Access;
      end record;
   
   type Docume_Access is access all Docume_Record;
   
   procedure Docume_Free (Docume : in out Docume_Access);

end El.Docume ; 
