-- This program is the last attempt of artificial intelligency with Ada.
-- Elhoim is Copyright (C) 2023 Manuel ; 
--
--   This program is free software; you can redistribute it and/or modify
--   it under the terms of the GNU General Public License as published by
--   the Free Software Foundation; either version 2 of the License, or
--   (at your option) any later version.
--
--   This program is distributed in the hope that it will be useful,
--   but WITHOUT ANY WARRANTY; without even the implied warranty of
--   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
--   GNU General Public License for more details.
--
--   You should have received a copy of the GNU General Public License
--   along with this program; if not, write to the Free Software
--   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
--
-- Date := "2023-05-03 13:14:19"
-- Version := "1.0.0b"
with Lib.Strings;
generic
package Lib.Classe.Events_class is
   use Strings;
   function Event_Value(Line : in Wide_String) return Name_Type;
   --------------------------------------------------------------------------
   --                   Event
   subtype Date_Wstring is Wide_String(1..19);
   
   function Date_Value(Line : in Wide_String) return Date_Wstring;
   
   type Event_Class is new Abstracted_Class(Event) with
      record
	 Event_Date : Date_Wstring := (others => Wide_Character'Val(32));
      end record;
   
   function Create(Win       : in Window_Type;
		   Win_Index : in out Positive;
		   Date      : in Time;
		   Name      : in Name_Type) return Abstracted_Access;
   
   procedure Print (Object    : in Event_Class'Class;
		    Win       : in Window_Type;
		    Win_Index : in out Positive;
		    Name      : out Name_Type);
   
   procedure Help(Event     : in out Event_Class'Class;
		  Win       : in Window_Type;
		  Win_Index : in out Positive;
		  Name      : out Name_Type);
   
   procedure Write (O : in Event_Class;File : in W_Io.File_Type);
   procedure Read (O : in out Event_Class;File : in W_Io.File_Type);
   procedure Random (O : in out Event_Class);
   --                End Event
   --------------------------------------------------------------------------

end Lib.Classe.Events_class ; 
