-- This program is the last attempt of artificial intelligency with Ada.
-- Elhoim is Copyright (C) 2023 Manuel ; 
--
--   This program is free software; you can redistribute it and/or modify
--   it under the terms of the GNU General Public License as published by
--   the Free Software Foundation; either version 2 of the License, or
--   (at your option) any later version.
--
--   This program is distributed in the hope that it will be useful,
--   but WITHOUT ANY WARRANTY; without even the implied warranty of
--   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
--   GNU General Public License for more details.
--
--   You should have received a copy of the GNU General Public License
--   along with this program; if not, write to the Free Software
--   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
--
-- Date := "2023-05-03 13:14:19"
-- Version := "1.0.0b"
with Lib.Strings;
generic
package Lib.Classe.Plans_class is
   use Strings;
   function Object_Name(Line : in Wide_String) return Name_Type;
   function Plan_description_Value(Line : in Wide_String) return Wstring_64;
   function Period_Value(Line : in Wide_String) return Duration;
   --------------------------------------------------------------------------
   --                   Plan
   type Plan_Class is new Abstracted_Class(Plan) with
      record
	 Plan_Date : Time := Clock;
	 end_Date : Time := Clock;
	 Period    : Duration := 0.0;
	 Description : Wstring_64 := (others => Wide_Character'Val(32));
      end record;
   
   function Create(Win       : in Window_Type;
		   Win_Index : in out Positive;
		   Name      : in Name_Type;
		   Date      : in Time;		   
		   Period    : in Duration;		   
		   Description : in Wstring_64
		  ) return Abstracted_Access;
   
   procedure Print (Object    : in Plan_Class'Class;
		    Win       : in Window_Type;
		    Win_Index : in out Positive;
		    Name      : out Name_Type);
   
   procedure Help(Plan     : in out Plan_Class'Class;
		  Win       : in Window_Type;
		  Win_Index : in out Positive;
		  Name      : out Name_Type);
   
   procedure Write (O : in Plan_Class;File : in W_Io.File_Type);
   procedure Read (O : in out Plan_Class;File : in W_Io.File_Type);
   procedure Random (O : in out Plan_Class);
   --                End Plan
   --------------------------------------------------------------------------

end Lib.Classe.Plans_class ; 
