-- This program is the last attempt of artificial intelligency with Ada.
-- Elhoim is Copyright (C) 2023 Manuel ; 
--
--   <one line to give the program's name and a brief idea of what it does.>
--   Copyright (C) 19yy  <name of author>
--
--   This program is free software; you can redistribute it and/or modify
--   it under the terms of the GNU General Public License as published by
--   the Free Software Foundation; either version 2 of the License, or
--   (at your option) any later version.
--
--   This program is distributed in the hope that it will be useful,
--   but WITHOUT ANY WARRANTY; without even the implied warranty of
--   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
--   GNU General Public License for more details.
--
--   You should have received a copy of the GNU General Public License
--   along with this program; if not, write to the Free Software
--   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
--
-- Date := "2023-05-01 20:03:01"
-- Version := "1.0.0a"
with Lib.Classe ;
------------------------------------------------------
--
--
with Lib.Classe.Universe_class;
with Lib.Classe.Notes_class;
with Lib.Classe.Contacts_class;
with Lib.Classe.Events_class;
with Lib.Classe.Animals_class;
with Lib.Classe.Accounting;
with Lib.Classe.Account_Lines_class;
with Lib.Classe.Cars_class;
with Lib.Classe.Houses_class;
with Lib.Classe.Contents_class;
with Lib.Classe.Activities_class;
with Lib.Classe.deallines_class;
with Lib.Classe.Planning_class;
with Lib.Classe.Plans_class;
--
--
------------------------------------------------------
with Lib.Strings ;

package Lib.Client is
   
   use Strings ;
   type Textual_Interface_Record is limited private;
   
   type Textual_Interface_Access is access Textual_Interface_Record;
   
   
   type Client_Record;
   task type Client_Process (Client : access Client_Record) is
   end Client_Process;   
   type Client_Record is tagged limited
      record
	 Lines : Line_Range := Line_Range ' First;
	 Cols  : Column_Range := Column_Range ' First;
	 Proc  : Client_Process (Client_Record ' access);
	 Textual_Int : Textual_Interface_Access;
     end record;
   
private
   task type Textual_Thread_Type (Machine : access Textual_Interface_Record) is
      --entry Initialize (Errno : out Integer);
      entry Receive(Text : in String);
      entry Send(Text : out String_Access);
      entry Exhauste(Text : out String_Access);
      entry Halt;
   end Textual_Thread_Type;
   
   type Textual_Interface_Record is tagged limited
      record
	 Textual_Thread : Textual_Thread_Type(Textual_Interface_Record ' access);
      end record;
   
   
   
end Lib.Client ; 
