-- This program is the last attempt of artificial intelligency with Ada.
-- Elhoim is Copyright (C) 2023 Manuel ; 
--
--   This program is free software; you can redistribute it and/or modify
--   it under the terms of the GNU General Public License as published by
--   the Free Software Foundation; either version 2 of the License, or
--   (at your option) any later version.
--
--   This program is distributed in the hope that it will be useful,
--   but WITHOUT ANY WARRANTY; without even the implied warranty of
--   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
--   GNU General Public License for more details.
--
--   You should have received a copy of the GNU General Public License
--   along with this program; if not, write to the Free Software
--   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
--
-- Date := "2023-05-01 20:03:01"
-- Version := "1.0.0a"
package Lib.Organe is
   
   use Parameters;
   Objects_Params : constant Objects_Parameters_Type := Objects_Parameters_Type(params);
   package Objects_system is new Gnos.Objects(Objects_Params);
   
   System_Params : Parameters.System_Parameters_Type := Params;
   
   use Objects_System;
   use Objects_System.Name_8;
   use Objects_System.Name_12;
   use Objects_System.Name_16;
   use Objects_system.Language;
   use Objects_system.Language.Agnose_Projects;

   function Random_name(char_index : in char_index_type) return string;

   type System_Context_Record is new Objects_System.Objects_Context_record with
     
      record 
	 System_Params : Parameters.System_Parameters_Type := Systems.System_Params;
      end record;
   
   
   procedure initialize(System_Context : in out System_Context_Record;
			System_Params  : in System_Parameters_Type);
   procedure Load_Project(System_Context : in out System_Context_Record;			
			Ada_Path : in String;
			Gtk_Path : in String;
			Aws_Path : in String;
			Project_Path : in String);
   
   function Check_Parameters(System_Context : in System_Context_Record'Class;
			    Params : in System_Parameters_Type'class) return Boolean;
   
   
   type System_record is new Objects_System.Objects_system with
      record
	 null;
      end record;
end Lib.Organe ; 
